#include <stdio.h>
#include <string.h>

/* This procedure reads one encoded block from the image file and stores a count
and data byte. Result:
0 = valid data stored
EOF = out of data in file */
encget(pbyt, pcnt, fid)
int *pbyt;     /* where to place data */
int *pcnt;     /* where to place count */
FILE *fid;     /* image file handle */
{
int i;
	*pcnt = 1;     /* safety play */
	if(EOF    ==    (i    =    getc(fid))) return(EOF);
	if(0xc0 == (0xc0 & i))   {
 	*pcnt = 0x3f&i;
	if(EOF == (i=getc(fid)))
			return(EOF);
}
*pbyt = i;
return(0);
}

static void decode( FILE *fid, FILE *out)
{
int bit, i, Hres, chr, cnt, TRIPLE = 0;

/* grab some data from the 128 byte header */
for(bit=0; bit < 128; bit++)
{
    i = getc(fid);
    if (bit == 66)
         Hres = i;  /* bytes per line */
}
bit = 0;
putc(' ',out);
putc('%',out);

while (EOF != encget(&chr, &cnt, fid))
{
    for(cnt; cnt > 0; cnt--)
    {
        if (chr){
            if (TRIPLE == 0)
                putc('0',out);
        }
        else{
            if (TRIPLE == 0)
                putc('1',out);            
        }
        bit++;
        if ((bit % 8) == 0)              /* spacing */
        {
            if ((bit % Hres) == 0)
            {
                TRIPLE++;
                if (TRIPLE == 3){
                    TRIPLE = 0;                
                    putc('\n',out);
                    putc(' ',out);
                }
            }   
            else{
                if (TRIPLE == 0)
                    putc(',',out); 
            }
        if (TRIPLE == 0)
            putc('%',out);   
        }                
    } 
} /* end while EOF */
} /* end decode */


main(argc,argv)
int argc;
char **argv;
{
   if (argc > 1) {
      FILE *file, *out;

      file = fopen(argv[1], "r");
      if (!file) {
         fprintf(stderr,"Invalid pcx source file: %s\n",argv[1]);
         exit(1);
      }
      
      if (argc == 3)
      {
          if ((out = fopen(argv[2], "w")) == NULL)
          {
              fprintf(stderr,"Invalid output file: %s\n",argv[2]);
              exit(1);      
          }
      }
      else
      {
          if ((out = fopen("untitled", "w")) == NULL)
          {
              fprintf(stderr,"Output File not Specified");
              exit(1);
          }
      }   
      
      decode(file,out);
   }
   else
   {
       printf("\n");
       printf("Sprite Maker by Harper Maddox\n");
       printf("   converts variable sized pcx files to output");      
       printf("\n");
       printf("USAGE-  sprmaker [*.pcx] [*.*]\n");
       printf("\n");
   }   
   return 1;
}


